# API-update

Wat te doen bij een nieuwe versie van Pure en dus een nieuwe versie vam de API.

## Achtergrond

Pure ondersteunt meerdere API-versies voor enige tijd.
Dat geeft ontwikkelaars de tijd om rustig aan de overstap naar een nieuwe AP te wennen.

Wanneer versie 5.15 uitkomt, is er ook een API '515'.
Dar kan je in principe een paar jaar mee werken.
Beter pas je de code snel aan aan die nieuwe API.

## Code en XSD

In class ResearchOutputsDAO en in class PureRemoteFactory de versie ophogen.
Er wordt gerefereerd naar een XSD.
In core/src/main/resources die nieuwe XSD downloaden vanaf Test:

```
$ wget -O schema-pure-ws-515.xsd "https://test.pure.uvt.nl/ws/api/515/xsd/schema1.xsd"``
```

Pure kan uitgebreid zijn met nieuwe publicatie-typen.
Controleer de nieuwe XSD aan de hand van instructies die je in Publication.java vindt.
Maak nieuwe typen aan zoals bestaande en kijk of er typen zijn vervallen.

## Test POST XML tegen schema

In terminal naar dorectory core/src/test/resources

Test voorbeeld-query tegen schema:

```
$ xmllint --schema ../../main/resources/schema-pure-ws-515.xsd few-discussion-papers.xml

...
few-discussion-papers.xml validates
```

Als dat valideert, hoeft het template voor deze query waarschijnlijk niet te worden aangepast.

Voor zekerheid in script test-post.sh API-versie aanpassen en script runnen:

```
$ ./test-post.sh <apiKey>

...
```

De API key is een UUID die je rechten geeft op resources in de API.

Geeft het heel veel XML-output, dan prima.

## Test data

In core/src/test/resources de nieuwe test-data ophalen:

```
$ ./fetch-test-data.sh <apiKey>
```

In tests wordt gerefereerd aan data die nu opgehaald is.
Als de API is aangepast, kunnen er tests falen, maar dat kan ook doordat er aan een record wat is aangepast.
Of omdat een record een andere positie heeft gekregen in het resultaat.

## API reference

Ga naar https://test.pure.uvt.nl/ws/api/515/api-docs/index.html of nieuwere API als er wat mis gaat en requests anders moeten.
Eerst Authorize doen met een API key (UUID).
