# PF

## Introductie

PF is de opvolger van Purefaçade.
Purefaçade maakte het eenvoudig mogelijk om data uit de Pure webservices beschikbaar te krijgen in de website,
in de vorm van HTML, RSS of vCards.
Purefaçade bood veel mogelijkheden.
Een aantal ervan kunnen worden overgenomen door de nieuwe Pure Portal.
Veel opties werden in de praktijk niet gebruikt.
Sommige opties waren nuttig toen Purefaçade gebouwd werd, maar zijn dat nu niet meer.
Caching, bijvoorbeeld, was in het begin nodig omdat Pure heel traag was.
Nu zit caching meer in de weg dan dat het nuttig is.
Pure heeft een eenvoudiger API gekregen, wat het parsen van de output van de webservices zeer sterk heeft vereenvoudigd.
PF gebruikt de nieuwe API van Pure webservices.
Verder wordt nu de APA-rendering van Pure zelf gebruikt, wat zeer veel programmatuur scheelt.
PF is daarom een systeem dat maar een paar dingen kan, en met veel minder opties.

Het volgende sequence-diagram beschijft de werking:

![UML Sequence Diagram](sequence.png)

Toelichting: iemand bezoekt een pagina in de website met content uit Pure.
Er wordt dan een verzoek gedaan aan PF om bijvoorbeeld een RSS feed van recente publicaties van een faculteit.
PF roept dan een of meer keer Pure Webservices aan, die de data weer uit de Pure database haalt.
Wanneer alle data verzameld is, verwerkt PF dat en levert het af als één document, bijvoorbeeld dus RSS.
Drupal verwerkt de gegevens in een webpagina en levert die aan de bezoeker.

## Beperkte toegang

Toegang tot de service kan beperkt zijn om persoonsdata af te schermen en om te voorkomen dat getoonde gegevens in Webwijs worden aangepast.

## Features

- Series, zoals CentER Discussion Paper-series, voor een jaar, gesorteerd op afnemend volume als RSS
- UUID van wetenschapper gegeven de mailnaam
- Data medewerkers t.b.v. Experts & Expertise (Webwijs)

## Gebruik

Alle getoonde URLs en links in de voorbeelden zijn herschreven naar de omgeving waar PF draait.

### GET /organisations/organisation;{id=[Id] | uuid=[uuid]}/recent-publications

RSS van 20 recentste publicaties van de organisatie en alle suborganisaties,
gesorteerd op afnemende publicatiedatum

Geef dus OF het ID van de organisatie mee als ';id=[id]' OF de UUID als ';uuid=[uuid]'.

Voorbeelden:

- [${base-url}/organisations/organisation;id=50000115/recent-publications](${base-url}/organisations/organisation;id=50000115/recent-publications) : RSS van Tilburg Law School via de ID
- [${base-url}/organisations/organisation;uuid=d50fd956-2133-47d3-9dc9-cc37ecaa6ba6/recent-publications](${base-url}/organisations/organisation;uuid=d50fd956-2133-47d3-9dc9-cc37ecaa6ba6/recent-publications) : RSS van Tilburg School of Economics and Management

### GET /persons/select?id=[ANR]...

Experts & Expertise-data van een aantal personen

Geeft de actuele XML van een selectie van personen.
Data komt niet uit de cache.

Werking wijkt af en gebruikt data uit middleware die data uit PGPRD bevat.
Volgende sequence-diagram beschrijft het proces voor 1 persoon.
Bij meerdere personen herhaalt zich communicatie van PF met PGPRD en PureWS.

![UML Sequence Diagram](select.png)

Geef 1 of meer ANR's op via herhaalde '&id=<ANR>' request-parameters.

Voorbeeld: [${base-url}/persons/select?id=178071](${base-url}/persons/select?id=178071) : de XML van Fred Vos

### GET /persons/cache-file-statistics

Statistieken over nieuwste en laatste goedgekeurde XML van Experts & Expertise-data

Geeft application/xml terug.

Voorbeeld: [${base-url}/persons/cache-file-statistics](${base-url}/persons/cache-file-statistics) 

### GET /persons/ee-data-cache-latest-stable

Laatste stabiele (=goedgekeurde) versie van de Experts & Expertise-data

Geeft application/xml terug (groot bestand).

Het bestand wordt periodiek gemaakt en vervangen op initiatief van PF zelf, via een soort cron-proces (Quartz).
Het volgende sequence-diagram beschrijft de werking.

![UML Sequence Diagram](ee-data.png)

Periodiek haalt PF een lijst op met persoons-ID's waarvoor er data in het XML-bestand moet komen.
Per persoon wordt dan de data uit PGPRD opgevraagd en die uit Pure erbij gezet indien de persoon een wetenschapper is.
Al die personen samen vormen een groot XML-bestand dat wordt opgeslagen als 'newest' versie.
Het bestand wordt gecontroleerd op diverse kengetallen en - indien goedgekeurd - gekopieerd naar 'stable'.

Bij dit verzoek wordt de laatst goedgekeurde versie ('stable') van het bestand opgehaald.

Voorbeeld: [${base-url}/persons/ee-data-cache-latest-stable](${base-url}/persons/ee-data-cache-latest-stable) 

### GET /persons/ee-data-cache-newest

Nieuwste versie van de Experts & Expertise-data

Deze is dezelfde als 'latest stable' indien goedgekeurd.
Wanneer niet goedgekeurd, wordt dit bestand niet gekopieerd naar 'latest stable'.

Geeft application/xml terug (groot bestand).

Voorbeeld: [${base-url}/persons/ee-data-cache-newest](${base-url}/persons/ee-data-cache-newest) 

### GET /persons/person;id=[ID]/drupal-id

Drupal-ID zoals in URL van profielpagina

Voorbeeld: [${base-url}/persons/person;id=178071/drupal-id](${base-url}/persons/person;id=178071/drupal-id) : Drupal-ID van Fred Vos

### GET /persons/person;{id=[ID]|mailname=[MAILNAAM]}/uuid

UUID van wetenschapper gegeven het id (ANR) of de mailnaam

Mailnaam is case-insensitive.

Voorbeeld: [${base-url}/persons/person;mailname=T.A.Klimstra/uuid](${base-url}/persons/person;mailname=T.A.Klimstra/uuid) : UUID van Theo Klimstra

Vanwege privacy kan er geen voorbeeld worden gegeven met het id (ANR).

### GET /series?series=[NAAM-SERIES]&publication-year=[JAAR]&document-type={thesisdoc|discussionpaper}

Series van een jaar compleet als RSS

Een RSS feed van publicaties van een zekere serie voor een jaar.
Publicaties gesorteerd op afnemend volume.

Request parameter 'series' is verplicht; voor de andere twee gelden defaults, maar geef deze toch liever op om voor anderen expliciet te zijn over wat je vraagt.

Request parameter value voor 'series' moet letterlijk overeenstemmen met die vastgelegd in Pure, maar is wel case insensitive.

Request parameter value voor 'publication-year' is het jaar in vier cijfers of een delta ten opzichte van het huidige jaar, wanneer het vanaf -10 t/m +10 is.
Dus: 'publication-year=2019' is in 2019 hetzelfde als 'publication-year=0'.
In 2019 betekent 'publication-year=-1' dus 2018 en 'publication-year=1' dus 2020.
Default is 0, dus geef je parameter 'publication-year' niet op, dan wordt het het huidige jaar.

Request parameter value voor 'document-type' is een van de opties zoals - door pipe-tekens gescheiden - bij URL beschreven.
Elke andere waarde is niet correct.
De programmatuur vertaalt deze verkorte namen naar de lange URI die Pure intern aanhoudt voor document type.
Hier geldt de eerstgenoemde in de URL-beschrijving als default.
Maak van de default-optie liever geen gebruik, omdat anderen jouw URL ook moeten begrijpen.

Dit verzoek leidt in de regel tot meerdere verzoeken aan Pure, waarbij veel meer wordt opgehaald dan nodig is.
Achteraf wordt er dan gefilterd.
Daardoor is dit verzoek relatief traag met antwoorden.
Indien mogelijk, dan de frequentie van opvragen beperken; bijvoorbeeld niet elke 5 minuten hernieuwd opvragen als een pagina open blijft staan.

Voorbeelden:

- [${base-url}/series?series=CentER%20Discussion%20Paper&publication-year=2014&document-type=discussionpaper](${base-url}/series?series=CentER%20Discussion%20Paper&publication-year=2014&document-type=discussionpaper) : CentER Discussion Paper series van 2014
  
- [${base-url}/series?series=CentER%20Dissertation%20Series&publication-year=2016&document-type=thesisdoc](${base-url}/series?series=CentER%20Dissertation%20Series&publication-year=2016&document-type=thesisdoc) : CentER Dissertation Series van 2016

- [${base-url}/series?series=CentER%20Dissertation%20Series&publication-year=0&document-type=thesisdoc](${base-url}/series?series=CentER%20Dissertation%20Series&publication-year=0&document-type=thesisdoc) : CentER Dissertation Series van dit jaar

- [${base-url}/series?series=TiCC%20Ph.D.%20Series&publication-year=2017&document-type=thesisdoc](${base-url}/series?series=TiCC%20Ph.D.%20Series&publication-year=2017&document-type=thesisdoc) : TiCC Ph.D. Series van 2017

### /status

Status van PF

Kan zowel text/html als application/xml geven.
Applicaties kunnen aangeven dat ze application/xml willen.

Voorbeeld: [${base-url}/status](${base-url}/status)

## Verder

### Release notes

Deze vind je [hier](release-notes).

### Roadmap

Deze vind je [hier](roadmap).
